﻿using BeeIt.TowerDefense.Contracts.Interfaces;using BeeIt.TowerDefense.Contracts.Math;using BeeIt.TowerDefense.Logic.Enemies;using System.Collections.Generic;
namespace BeeIt.TowerDefense.Logic.Game{	// ============================================================================================================================	// D. Generika - abstrakce na úrovni typů	// ============================================================================================================================	internal class Statistics	{		private ICounter<IEnemy> _counterGeneralEnemy;		private ICounter<ArmoredEnemy> _counterArmored;
		public Statistics()		{			_counterGeneralEnemy = new Counter<IEnemy>();			_counterArmored = new Counter<ArmoredEnemy>();		}
		public int CalculateHitPoints(IEnumerable<IEnemy> enemies)		{			FillGenerics(enemies);
			return CalculateHitPointsWithSum(enemies);			//return CalculateHitPointsWithGenerics(enemies);		}
		// ============================================================================================================================		// Spočítejte kolik ran je potřeba ještě vystřelit, aby všechny postavičky umřely. Výpočet proveďťe pomocí obyčejné smyčky		// 1. Definujte lokální proměnnou sum typu int a inicializujte ji na 0		// 2. Projděte seznam enemies pomocí foreach cyklu		// 3. Pro ArmoredEnemy přidejte do sum Health a Armor		// 4. Pro zbytek postaviček přidejte pouze Health 		public int CalculateHitPointsWithSum(IEnumerable<IEnemy> enemies)		{			return 0;		}
		// ============================================================================================================================		// Spočítejte kolik ran je potřeba ještě vystřelit, aby všechny postavičky umřely. Výpočet proveďťe pomocí generik		// 1. Projděte seznam enemies pomocí foreach cyklu		// 2. Přidejte ArmoredEnemy do _counterArmored		// 3. Přidejte zbytek do _counterGeneralEnemy		// 4. Spočítejte součet pro _counterArmored a _counterGeneralEnemy jak v předchozím případě		public int CalculateHitPointsWithGenerics(IEnumerable<IEnemy> enemies)		{			return 0;		}
		private void FillGenerics(IEnumerable<IEnemy> enemies)		{			_counterArmored.Clear();			_counterGeneralEnemy.Clear();
			foreach (var enemy in enemies)			{				if (enemy is ArmoredEnemy)				{					_counterArmored.Add(enemy as ArmoredEnemy);				}				else				{					_counterGeneralEnemy.Add(enemy);				}			}		}	}}